
(* control.sml *)
(* See Filinski's thesis *)

(* 

Define shift and reset

*)

signature CONTROL = 
    sig
        type ans
        val reset : (unit -> ans) -> ans
        val shift : (('a -> ans) -> ans) -> 'a
    end

functor Control (type ans) : CONTROL = 
    struct
        
        open Escape
        exception MissingReset

        val mk : (ans -> void) ref = ref (fn _ => raise MissingReset)
        fun abort x = !mk x

        type ans = ans

        fun reset t = 
            escape (fn k => let val m = !mk
                            in mk := (fn r => (mk := m; k r));
                               abort (t())
                            end)

        fun shift h = 
            escape (fn k => abort (h (fn v => reset (fn () => coerce (k v)))))

    end