
(* escape.sml *)
(* See Filinski's thesis *)

(* 

Define escape and coerce which are essentially identical to callcc and
throw but with types that look like regular function types instead of
the special 'a cont types used by SML. This allows us to easily store
continuations in reference cells.

*)

signature ESCAPE = 
    sig
        type void
        val coerce : void -> 'a
        val escape : (('a -> void) -> void) -> 'a
    end

structure Escape : ESCAPE = 
    struct

        val callcc = SMLofNJ.Cont.callcc
        val throw = SMLofNJ.Cont.throw

        datatype void = VOID of void

        fun coerce (VOID v) = coerce v

        fun escape f = callcc (fn k => coerce (f (fn x => throw k x)))
    end
